## linux 6.12.31

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
VERSION = 6
PATCHLEVEL = 12
SUBLEVEL = 31
EXTRAVERSION =
NAME = Baby Opossum Posse

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

ifeq ($(filter output-sync,$(.FEATURES)),)
$(error GNU Make >= 4.0 is required. Your Make version is $(MAKE_VERSION))
endif

$(if $(filter __%, $(MAKECMDGOALS)), \
	$(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.a targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

this-makefile := $(lastword $(MAKEFILE_LIST))
abs_srctree := $(realpath $(dir $(this-makefile)))
abs_objtree := $(CURDIR)

ifneq ($(sub_make_done),1)

# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour)
MAKEFLAGS += -rR

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# Beautify output
# ---------------------------------------------------------------------------
#
# Most of build commands in Kbuild start with "cmd_". You can optionally define
# "quiet_cmd_*". If defined, the short log is printed. Otherwise, no log from
# that command is printed by default.
#
# e.g.)
#    quiet_cmd_depmod = DEPMOD  $(MODLIB)
#          cmd_depmod = $(srctree)/scripts/depmod.sh $(DEPMOD) $(KERNELRELEASE)
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#    $(Q)$(MAKE) $(build)=scripts/basic
#
# If KBUILD_VERBOSE contains 1, the whole command is echoed.
# If KBUILD_VERBOSE contains 2, the reason for rebuilding is printed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif

quiet = quiet_
Q = @

ifneq ($(findstring 1, $(KBUILD_VERBOSE)),)
  quiet =
  Q =
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands
ifneq ($(findstring s,$(firstword -$(MAKEFLAGS))),)
quiet=silent_
override KBUILD_VERBOSE :=
endif

export quiet Q KBUILD_VERBOSE

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/dev-tools/sparse.rst" for more details,
# including where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

export KBUILD_CHECKSRC

# Enable "clippy" (a linter) as part of the Rust compilation.
#
# Use 'make CLIPPY=1' to enable it.
ifeq ("$(origin CLIPPY)", "command line")
  KBUILD_CLIPPY := $(CLIPPY)
endif

export KBUILD_CLIPPY

# Use make M=dir or set the environment variable KBUILD_EXTMOD to specify the
# directory of external module to build. Setting M= takes precedence.
ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

$(if $(word 2, $(KBUILD_EXTMOD)), \
	$(error building multiple external modules is not supported))

$(foreach x, % :, $(if $(findstring $x, $(KBUILD_EXTMOD)), \
	$(error module directory path cannot contain '$x')))

# Remove trailing slashes
ifneq ($(filter %/, $(KBUILD_EXTMOD)),)
KBUILD_EXTMOD := $(shell dirname $(KBUILD_EXTMOD).)
endif

export KBUILD_EXTMOD

# backward compatibility
KBUILD_EXTRA_WARN ?= $(KBUILD_ENABLE_EXTRA_GCC_CHECKS)

ifeq ("$(origin W)", "command line")
  KBUILD_EXTRA_WARN := $(W)
endif

export KBUILD_EXTRA_WARN

# Kbuild will save output files in the current working directory.
# This does not need to match to the root of the kernel source tree.
#
# For example, you can do this:
#
#  cd /dir/to/store/output/files; make -f /dir/to/kernel/source/Makefile
#
# If you want to save output files in a different location, there are
# two syntaxes to specify it.
#
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the output directory.
# export KBUILD_OUTPUT=dir/to/store/output/files/; make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# Do we want to change the working directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# $(realpath ...) gets empty if the path does not exist. Run 'mkdir -p' first.
$(shell mkdir -p "$(KBUILD_OUTPUT)")
# $(realpath ...) resolves symlinks
abs_objtree := $(realpath $(KBUILD_OUTPUT))
$(if $(abs_objtree),,$(error failed to create output directory "$(KBUILD_OUTPUT)"))
endif # ifneq ($(KBUILD_OUTPUT),)

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

export sub_make_done := 1

endif # sub_make_done

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." if we are at the final work directory.
no-print-directory := --no-print-directory
else
# Recursion to show "Entering directory ..."
need-sub-make := 1
endif

ifeq ($(filter --no-print-directory, $(MAKEFLAGS)),)
# If --no-print-directory is unset, recurse once again to set it.
# You may end up recursing into __sub-make twice. This is needed due to the
# behavior change in GNU Make 4.4.1.
need-sub-make := 1
endif

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) $(no-print-directory) -C $(abs_objtree) \
	-f $(abs_srctree)/Makefile $(MAKECMDGOALS)

else # need-sub-make

# We process the rest of the Makefile if this is the final invocation of make

ifeq ($(abs_srctree),$(abs_objtree))
        # building in the source tree
        srctree := .
	building_out_of_srctree :=
else
        ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(abs_srctree)
        endif
	building_out_of_srctree := 1
endif

ifneq ($(KBUILD_ABS_SRCTREE),)
srctree := $(abs_srctree)
endif

objtree		:= .

VPATH		:=

ifeq ($(KBUILD_EXTMOD),)
ifdef building_out_of_srctree
VPATH		:= $(srctree)
endif
endif

export building_out_of_srctree srctree objtree VPATH

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

version_h := include/generated/uapi/linux/version.h

clean-targets := %clean mrproper cleandocs
no-dot-config-targets := $(clean-targets) \
			 cscope gtags TAGS tags help% %docs check% coccicheck \
			 $(version_h) headers headers_% archheaders archscripts \
			 %asm-generic kernelversion %src-pkg dt_binding_check \
			 outputmakefile rustavailable rustfmt rustfmtcheck
no-sync-config-targets := $(no-dot-config-targets) %install modules_sign kernelrelease \
			  image_name
single-targets := %.a %.i %.ko %.lds %.ll %.lst %.mod %.o %.rsi %.s %.symtypes %/

config-build	:=
mixed-build	:=
need-config	:= 1
may-sync-config	:= 1
single-build	:=

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
        need-config :=
    endif
endif

ifneq ($(filter $(no-sync-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-sync-config-targets), $(MAKECMDGOALS)),)
        may-sync-config :=
    endif
endif

need-compiler := $(may-sync-config)

ifneq ($(KBUILD_EXTMOD),)
    may-sync-config :=
endif

ifeq ($(KBUILD_EXTMOD),)
    ifneq ($(filter %config,$(MAKECMDGOALS)),)
        config-build := 1
        ifneq ($(words $(MAKECMDGOALS)),1)
            mixed-build := 1
        endif
    endif
endif

# We cannot build single targets and the others at the same time
ifneq ($(filter $(single-targets), $(MAKECMDGOALS)),)
    single-build := 1
    ifneq ($(filter-out $(single-targets), $(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

# For "make -j clean all", "make -j mrproper defconfig all", etc.
ifneq ($(filter $(clean-targets),$(MAKECMDGOALS)),)
    ifneq ($(filter-out $(clean-targets),$(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

# install and modules_install need also be processed one by one
ifneq ($(filter install,$(MAKECMDGOALS)),)
    ifneq ($(filter modules_install,$(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

ifdef mixed-build
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

PHONY += $(MAKECMDGOALS) __build_one_by_one

$(MAKECMDGOALS): __build_one_by_one
	@:

__build_one_by_one:
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done

else # !mixed-build

include $(srctree)/scripts/Kbuild.include

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(call read-file, include/config/kernel.release)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
export VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION

include $(srctree)/scripts/subarch.include

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=arm64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=aarch64-linux-gnu-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
ARCH		?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc32)
       SRCARCH := sparc
endif
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for parisc
ifeq ($(ARCH),parisc64)
       SRCARCH := parisc
endif

export cross_compiling :=
ifneq ($(SRCARCH),$(SUBARCH))
cross_compiling := 1

=== drivers/ptp/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for PTP 1588 clock support.
#

ptp-y					:= ptp_clock.o ptp_chardev.o ptp_sysfs.o ptp_vclock.o
ptp_kvm-$(CONFIG_X86)			:= ptp_kvm_x86.o ptp_kvm_common.o
ptp_kvm-$(CONFIG_HAVE_ARM_SMCCC)	:= ptp_kvm_arm.o ptp_kvm_common.o
obj-$(CONFIG_PTP_1588_CLOCK)		+= ptp.o
obj-$(CONFIG_PTP_1588_CLOCK_DTE)	+= ptp_dte.o
obj-$(CONFIG_PTP_1588_CLOCK_INES)	+= ptp_ines.o
obj-$(CONFIG_PTP_1588_CLOCK_PCH)	+= ptp_pch.o
obj-$(CONFIG_PTP_1588_CLOCK_KVM)	+= ptp_kvm.o
obj-$(CONFIG_PTP_1588_CLOCK_QORIQ)	+= ptp-qoriq.o
ptp-qoriq-y				+= ptp_qoriq.o
ptp-qoriq-$(CONFIG_DEBUG_FS)		+= ptp_qoriq_debugfs.o
obj-$(CONFIG_PTP_1588_CLOCK_IDTCM)	+= ptp_clockmatrix.o
obj-$(CONFIG_PTP_1588_CLOCK_FC3W)	+= ptp_fc3.o
obj-$(CONFIG_PTP_1588_CLOCK_IDT82P33)	+= ptp_idt82p33.o
obj-$(CONFIG_PTP_1588_CLOCK_MOCK)	+= ptp_mock.o
obj-$(CONFIG_PTP_1588_CLOCK_VMW)	+= ptp_vmw.o
obj-$(CONFIG_PTP_1588_CLOCK_OCP)	+= ptp_ocp.o
obj-$(CONFIG_PTP_DFL_TOD)		+= ptp_dfl_tod.o

=== kernel/printk/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-y	= printk.o
obj-$(CONFIG_PRINTK)	+= printk_safe.o nbcon.o
obj-$(CONFIG_A11Y_BRAILLE_CONSOLE)	+= braille.o
obj-$(CONFIG_PRINTK_INDEX)	+= index.o

obj-$(CONFIG_PRINTK)                 += printk_support.o
printk_support-y	             := printk_ringbuffer.o
printk_support-$(CONFIG_SYSCTL)	     += sysctl.o

=== lib/lz4/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
ccflags-y += -O3

obj-$(CONFIG_LZ4_COMPRESS) += lz4_compress.o
obj-$(CONFIG_LZ4HC_COMPRESS) += lz4hc_compress.o
obj-$(CONFIG_LZ4_DECOMPRESS) += lz4_decompress.o

=== arch/mips/n64/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Nintendo 64
#

obj-y := init.o irq.o

=== tools/testing/selftests/Makefile ===
# SPDX-License-Identifier: GPL-2.0
TARGETS += acct
TARGETS += alsa
TARGETS += amd-pstate
TARGETS += arm64
TARGETS += bpf
TARGETS += breakpoints
TARGETS += cachestat
TARGETS += capabilities
TARGETS += cgroup
TARGETS += clone3
TARGETS += connector
TARGETS += core
TARGETS += cpufreq
TARGETS += cpu-hotplug
TARGETS += damon
TARGETS += devices/error_logs
TARGETS += devices/probe
TARGETS += dmabuf-heaps
TARGETS += drivers/dma-buf
TARGETS += drivers/s390x/uvdevice
TARGETS += drivers/net
TARGETS += drivers/net/bonding
TARGETS += drivers/net/team
TARGETS += drivers/net/virtio_net
TARGETS += drivers/platform/x86/intel/ifs
TARGETS += dt
TARGETS += efivarfs
TARGETS += exec
TARGETS += fchmodat2
TARGETS += filesystems
TARGETS += filesystems/binderfs
TARGETS += filesystems/epoll
TARGETS += filesystems/fat
TARGETS += filesystems/overlayfs
TARGETS += filesystems/statmount
TARGETS += firmware
TARGETS += fpu
TARGETS += ftrace
TARGETS += futex
TARGETS += gpio
TARGETS += hid
TARGETS += intel_pstate
TARGETS += iommu
TARGETS += ipc
TARGETS += ir
TARGETS += kcmp
TARGETS += kexec
TARGETS += kvm
TARGETS += landlock
TARGETS += lib
TARGETS += livepatch
TARGETS += lkdtm
TARGETS += lsm
TARGETS += membarrier
TARGETS += memfd
TARGETS += memory-hotplug
TARGETS += mincore
TARGETS += mount
TARGETS += mount_setattr
TARGETS += move_mount_set_group
TARGETS += mqueue
TARGETS += nci
TARGETS += net
TARGETS += net/af_unix
TARGETS += net/forwarding
TARGETS += net/hsr
TARGETS += net/mptcp
TARGETS += net/netfilter
TARGETS += net/openvswitch
TARGETS += net/packetdrill
TARGETS += net/rds
TARGETS += net/tcp_ao
TARGETS += nsfs
TARGETS += perf_events
TARGETS += pidfd
TARGETS += pid_namespace
TARGETS += power_supply
TARGETS += powerpc
TARGETS += prctl
TARGETS += proc
TARGETS += pstore
TARGETS += ptrace
TARGETS += openat2
TARGETS += resctrl
TARGETS += riscv
TARGETS += rlimits
TARGETS += rseq
TARGETS += rtc
TARGETS += rust
TARGETS += sched_ext
TARGETS += seccomp
TARGETS += sgx
TARGETS += sigaltstack
TARGETS += size
TARGETS += sparc64
TARGETS += splice
TARGETS += static_keys
TARGETS += sync
TARGETS += syscall_user_dispatch
TARGETS += sysctl
TARGETS += tc-testing
TARGETS += tdx
TARGETS += thermal/intel/power_floor
TARGETS += thermal/intel/workload_hint
TARGETS += timens
ifneq (1, $(quicktest))
TARGETS += timers
endif
TARGETS += tmpfs
TARGETS += tpm2
TARGETS += tty
TARGETS += uevent
TARGETS += user_events
TARGETS += vDSO
TARGETS += mm
TARGETS += x86
TARGETS += x86/bugs
TARGETS += zram
#Please keep the TARGETS list alphabetically sorted
# Run "make quicktest=1 run_tests" or
# "make quicktest=1 kselftest" from top level Makefile

TARGETS_HOTPLUG = cpu-hotplug
TARGETS_HOTPLUG += memory-hotplug

# Networking tests want the net/lib target, include it automatically
ifneq ($(filter net drivers/net drivers/net/hw,$(TARGETS)),)
ifeq ($(filter net/lib,$(TARGETS)),)
	INSTALL_DEP_TARGETS := net/lib
endif
endif

# User can optionally provide a TARGETS skiplist. By default we skip
# targets using BPF since it has cutting edge build time dependencies
# which require more effort to install.
SKIP_TARGETS ?= bpf sched_ext
ifneq ($(SKIP_TARGETS),)
	TMP := $(filter-out $(SKIP_TARGETS), $(TARGETS))
	override TARGETS := $(TMP)
endif

# User can set FORCE_TARGETS to 1 to require all targets to be successfully
# built; make will fail if any of the targets cannot be built. If
# FORCE_TARGETS is not set (the default), make will succeed if at least one
# of the targets gets built.
FORCE_TARGETS ?=

# Clear LDFLAGS and MAKEFLAGS when implicit rules are missing.  This provides
# implicit rules to sub-test Makefiles which avoids build failures in test
# Makefile that don't have explicit build rules.
ifeq (,$(LINK.c))
override LDFLAGS =
override MAKEFLAGS =
endif

# Append kselftest to KBUILD_OUTPUT and O to avoid cluttering
# KBUILD_OUTPUT with selftest objects and headers installed
# by selftests Makefile or lib.mk.
ifdef building_out_of_srctree
override LDFLAGS =
endif

top_srcdir ?= ../../..

ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
  # Make's built-in functions such as $(abspath ...), $(realpath ...) cannot
  # expand a shell special character '~'. We use a somewhat tedious way here.
  abs_objtree := $(shell cd $(top_srcdir) && mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) && pwd)
  $(if $(abs_objtree),, \
    $(error failed to create output directory "$(KBUILD_OUTPUT)"))
  # $(realpath ...) resolves symlinks
  abs_objtree := $(realpath $(abs_objtree))
  BUILD := $(abs_objtree)/kselftest
  KHDR_INCLUDES := -isystem ${abs_objtree}/usr/include
else
  BUILD := $(CURDIR)
  abs_srctree := $(shell cd $(top_srcdir) && pwd)
  KHDR_INCLUDES := -isystem ${abs_srctree}/usr/include
  DEFAULT_INSTALL_HDR_PATH := 1
endif

# Prepare for headers install
include $(top_srcdir)/scripts/subarch.include
ARCH           ?= $(SUBARCH)
export BUILD
export KHDR_INCLUDES

# set default goal to all, so make without a target runs all, even when
# all isn't the first target in the file.
.DEFAULT_GOAL := all

all:
	@ret=1;							\
	for TARGET in $(TARGETS); do				\
		BUILD_TARGET=$$BUILD/$$TARGET;			\
		mkdir $$BUILD_TARGET  -p;			\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET	\
				O=$(abs_objtree)		\
				$(if $(FORCE_TARGETS),|| exit);	\
		ret=$$((ret * $$?));				\
	done; exit $$ret;

run_tests: all
	@for TARGET in $(TARGETS); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET run_tests \
				SRC_PATH=$(shell readlink -e $$(pwd)) \
				OBJ_PATH=$(BUILD)                   \
				O=$(abs_objtree);		    \
	done;

hotplug:
	@for TARGET in $(TARGETS_HOTPLUG); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET;\
	done;

run_hotplug: hotplug
	@for TARGET in $(TARGETS_HOTPLUG); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET run_full_test;\
	done;

clean_hotplug:
	@for TARGET in $(TARGETS_HOTPLUG); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET clean;\
	done;

run_pstore_crash:
	$(MAKE) -C pstore run_crash

# Use $BUILD as the default install root. $BUILD points to the
# right output location for the following cases:
# 1. output_dir=kernel_src
# 2. a separate output directory is specified using O= KBUILD_OUTPUT
# 3. a separate output directory is specified using KBUILD_OUTPUT
# Avoid conflict with INSTALL_PATH set by the main Makefile
#
KSFT_INSTALL_PATH ?= $(BUILD)/kselftest_install
KSFT_INSTALL_PATH := $(abspath $(KSFT_INSTALL_PATH))
# Avoid changing the rest of the logic here and lib.mk.
INSTALL_PATH := $(KSFT_INSTALL_PATH)
ALL_SCRIPT := $(INSTALL_PATH)/run_kselftest.sh
TEST_LIST := $(INSTALL_PATH)/kselftest-list.txt

install: all
ifdef INSTALL_PATH
	@# Ask all targets to install their files
	mkdir -p $(INSTALL_PATH)/kselftest
	install -m 744 kselftest/module.sh $(INSTALL_PATH)/kselftest/
	install -m 744 kselftest/runner.sh $(INSTALL_PATH)/kselftest/
	install -m 744 kselftest/prefix.pl $(INSTALL_PATH)/kselftest/
	install -m 744 kselftest/ktap_helpers.sh $(INSTALL_PATH)/kselftest/
	install -m 744 kselftest/ksft.py $(INSTALL_PATH)/kselftest/
	install -m 744 run_kselftest.sh $(INSTALL_PATH)/
	rm -f $(TEST_LIST)
	@ret=1;	\
	for TARGET in $(TARGETS) $(INSTALL_DEP_TARGETS); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET install \
				INSTALL_PATH=$(INSTALL_PATH)/$$TARGET \
				SRC_PATH=$(shell readlink -e $$(pwd)) \
				OBJ_PATH=$(INSTALL_PATH) \
				O=$(abs_objtree)		\
				$(if $(FORCE_TARGETS),|| exit);	\
		ret=$$((ret * $$?));		\
	done; exit $$ret;


	@# Ask all targets to emit their test scripts
	@# While building kselftest-list.text skip also non-existent TARGET dirs:
	@# they could be the result of a build failure and should NOT be
	@# included in the generated runlist.
	for TARGET in $(TARGETS); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		[ ! -d $(INSTALL_PATH)/$$TARGET ] && printf "Skipping non-existent dir: $$TARGET\n" && continue; \
		printf "Emit Tests for $$TARGET\n"; \
		$(MAKE) -s --no-print-directory OUTPUT=$$BUILD_TARGET COLLECTION=$$TARGET \
			-C $$TARGET emit_tests >> $(TEST_LIST); \
	done;
else
	$(error Error: set INSTALL_PATH to use install)
endif

FORMAT ?= .gz
TAR_PATH = $(abspath ${INSTALL_PATH}/kselftest-packages/kselftest.tar${FORMAT})
gen_tar: install
	@mkdir -p ${INSTALL_PATH}/kselftest-packages/
	@tar caf ${TAR_PATH} --exclude=kselftest-packages -C ${INSTALL_PATH} .
	@echo "Created ${TAR_PATH}"

clean:
	@for TARGET in $(TARGETS); do \
		BUILD_TARGET=$$BUILD/$$TARGET;	\
		$(MAKE) OUTPUT=$$BUILD_TARGET -C $$TARGET clean;\
	done;

.PHONY: all run_tests hotplug run_hotplug clean_hotplug run_pstore_crash install clean gen_tar

=== arch/x86/platform/uv/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_X86_UV)		+= bios_uv.o uv_irq.o uv_time.o uv_nmi.o

=== drivers/crypto/intel/keembay/Makefile ===
#
# Makefile for Intel Keem Bay OCS Crypto API Linux drivers
#
obj-$(CONFIG_CRYPTO_DEV_KEEMBAY_OCS_AES_SM4) += keembay-ocs-aes.o
keembay-ocs-aes-objs := keembay-ocs-aes-core.o ocs-aes.o

obj-$(CONFIG_CRYPTO_DEV_KEEMBAY_OCS_ECC) += keembay-ocs-ecc.o

obj-$(CONFIG_CRYPTO_DEV_KEEMBAY_OCS_HCU) += keembay-ocs-hcu.o
keembay-ocs-hcu-objs := keembay-ocs-hcu-core.o ocs-hcu.o

=== drivers/infiniband/hw/mlx5/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_MLX5_INFINIBAND) += mlx5_ib.o

mlx5_ib-y := ah.o \
	     cmd.o \
	     cong.o \
	     counters.o \
	     cq.o \
	     data_direct.o \
	     dm.o \
	     doorbell.o \
	     gsi.o \
	     ib_virt.o \
	     mad.o \
	     main.o \
	     mem.o \
	     mr.o \
	     qp.o \
	     qpc.o \
	     restrack.o \
	     srq.o \
	     srq_cmd.o \
	     umr.o \
	     wr.o

mlx5_ib-$(CONFIG_INFINIBAND_ON_DEMAND_PAGING) += odp.o
mlx5_ib-$(CONFIG_MLX5_ESWITCH) += ib_rep.o
mlx5_ib-$(CONFIG_INFINIBAND_USER_ACCESS) += devx.o \
					    fs.o \
					    qos.o \
					    std_types.o
mlx5_ib-$(CONFIG_MLX5_MACSEC) += macsec.o

=== drivers/net/ethernet/intel/libeth/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
# Copyright (C) 2024 Intel Corporation

obj-$(CONFIG_LIBETH)		+= libeth.o

libeth-y			:= rx.o

=== drivers/net/wireless/mediatek/mt7601u/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_MT7601U)	+= mt7601u.o

mt7601u-objs	= \
	usb.o init.o main.o mcu.o trace.o dma.o core.o eeprom.o phy.o \
	mac.o util.o debugfs.o tx.o

CFLAGS_trace.o := -I$(src)

=== drivers/net/wireless/realtek/rtl8xxxu/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_RTL8XXXU)	+= rtl8xxxu.o

rtl8xxxu-y	:= core.o 8192e.o 8723b.o \
		   8723a.o 8192c.o 8188f.o \
		   8188e.o 8710b.o 8192f.o

=== debian/changelog ===
linux (6.12.31-1) trixie-security; urgency=high

  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v6.x/ChangeLog-6.12.31
    - drm/amd/display: Configure DTBCLK_P with OPTC only for dcn401
    - drm/amd/display: Do not enable replay when vtotal update is pending.
    - drm/amd/display: Correct timing_adjust_pending flag setting.
    - drm/amd/display: Defer BW-optimization-blocked DRR adjustments
    - i2c: designware: Use temporary variable for struct device
    - i2c: designware: Fix an error handling path in i2c_dw_pci_probe()
    - [arm64] phy: renesas: rcar-gen3-usb2: Move IRQ request in probe
    - [arm64] phy: renesas: rcar-gen3-usb2: Lock around hardware registers and
      driver data
    - [arm64] phy: renesas: rcar-gen3-usb2: Assert PLL reset on PHY power off
    - cpufreq: Add SM8650 to cpufreq-dt-platdev blocklist
    - [arm64] nvmem: rockchip-otp: Move read-offset into variant-data
    - [arm64] nvmem: rockchip-otp: add rk3576 variant data
    - nvmem: core: fix bit offsets of more than one byte
    - nvmem: core: verify cell's raw_len
    - nvmem: core: update raw_len if the bit reading is required
    - nvmem: qfprom: switch to 4-byte aligned reads
    - scsi: target: iscsi: Fix timeout on deleted connection
    - scsi: ufs: Introduce quirk to extend PA_HIBERN8TIME for UFS devices
    - virtio_ring: Fix data race by tagging event_triggered as racy for KCSAN
    - dma/mapping.c: dev_dbg support for dma_addressing_limited
    - [amd64] intel_th: avoid using deprecated page->mapping, index fields
    - [amd64] mei: vsc: Use struct vsc_tp_packet as vsc-tp tx_buf and rx_buf
      type
    - dma-mapping: avoid potential unused data compilation warning
    - cgroup: Fix compilation issue due to cgroup_mutex not being exported
    - vhost_task: fix vhost_task_create() documentation
    - vhost-scsi: protect vq->log_used with vq->mutex
    - scsi: mpi3mr: Add level check to control event logging
    - net: enetc: refactor bulk flipping of RX buffers to separate function
    - dma-mapping: Fix warning reported for missing prototype
    - ima: process_measurement() needlessly takes inode_lock() on MAY_READ
    - fs/buffer: split locking for pagecache lookups
    - fs/buffer: introduce sleeping flavors for pagecache lookups
    - fs/buffer: use sleeping version of __find_get_block()
    - fs/ocfs2: use sleeping version of __find_get_block()
    - fs/jbd2: use sleeping version of __find_get_block()
    - fs/ext4: use sleeping version of sb_find_get_block()
    - drm/amd/display: Enable urgent latency adjustment on DCN35
    - drm/amdgpu: Allow P2P access through XGMI
    - block: fix race between set_blocksize and read paths
    - io_uring: don't duplicate flushing in io_req_post_cqe
    - bpf: fix possible endless loop in BPF map iteration
    - kconfig: merge_config: use an empty file as initfile
    - [x86] fred: Fix system hang during S4 resume with FRED enabled
    - [s390x] vfio-ap: Fix no AP queue sharing allowed message written to kernel
      log
    - cifs: Add fallback for SMB2 CREATE without FILE_READ_ATTRIBUTES
    - cifs: Fix querying and creating MF symlinks over SMB1
    - cifs: Fix negotiate retry functionality
    - smb: client: Store original IO parameters and prevent zero IO sizes
    - fuse: Return EPERM rather than ENOSYS from link()
    - exfat: call bh_read in get_block only when necessary
    - io_uring/msg: initialise msg request opcode
    - NFSv4: Check for delegation validity in
      nfs_start_delegation_return_locked()
    - NFS: Don't allow waiting for exiting tasks
    - SUNRPC: Don't allow waiting for exiting tasks
    - [arm64] Add support for HIP09 Spectre-BHB mitigation
    - iommufd: Extend IOMMU_GET_HW_INFO to report PASID capability
    - tracing: Mark binary printing functions with __printf() attribute
    - ACPI: PNP: Add Intel OC Watchdog IDs to non-PNP device list
    - tpm: Convert warn to dbg in tpm2_start_auth_session()
    - [amd64,arm64] mailbox: pcc: Use acpi_os_ioremap() instead of ioremap()
    - mailbox: use error ret code of of_parse_phandle_with_args()
    - [riscv64] Allow NOMMU kernels to access all of RAM
    - fbdev: fsl-diu-fb: add missing device_remove_file()
    - fbcon: Use correct erase colour for clearing in fbcon
    - fbdev: core: tileblit: Implement missing margin clearing for tileblit
    - cifs: Set default Netbios RFC1001 server name to hostname in UNC
    - cifs: add validation check for the fields in smb_aces
    - cifs: Fix establishing NetBIOS session for SMB2+ connection
    - NFSv4: Treat ENETUNREACH errors as fatal for state recovery
    - SUNRPC: rpc_clnt_set_transport() must not change the autobind setting
    - SUNRPC: rpcbind should never reset the port to the value '0'
    - [arm64,armhf] spi-rockchip: Fix register out of bounds access
    - [arm64] ASoC: codecs: wsa883x: Correct VI sense channel mask
    - mctp: Fix incorrect tx flow invalidation condition in mctp-i2c
    - [arm64] thermal/drivers/mediatek/lvts: Start sensor interrupts disabled
    - [arm64] thermal/drivers/qoriq: Power down TMU on system suspend
    - Bluetooth: btmtksdio: Prevent enabling interrupts after IRQ handler
      removal
    - Bluetooth: Disable SCO support if READ_VOICE_SETTING is unsupported/broken
    - dql: Fix dql->limit value when reset.
    - lockdep: Fix wait context check on softirq for PREEMPT_RT
    - objtool: Properly disable uaccess validation
    - [arm64] PCI: dwc: ep: Ensure proper iteration over outbound map windows
    - r8169: disable RTL8126 ZRX-DC timeout
    - tools/build: Don't pass test log files to linker
    - pNFS/flexfiles: Report ENETDOWN as a connection error
    - drm/amdgpu/discovery: check ip_discovery fw file available
    - drm/amdkfd: set precise mem ops caps to disabled for gfx 11 and 12
    - PCI: vmd: Disable MSI remapping bypass under Xen
    - xen/pci: Do not register devices with segments >= 0x10000


=== debian/control ===
Source: linux
Section: kernel
Priority: optional
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, maximilian attems <maks@debian.org>, Ben Hutchings <benh@debian.org>, Salvatore Bonaccorso <carnil@debian.org>
Standards-Version: 4.2.0
Build-Depends: debhelper-compat (= 13), python3:native, python3-dacite:native, python3-jinja2:native, quilt, dh-python <!pkg.linux.notools>
Build-Depends-Arch: bc <!pkg.linux.nokernel>, libssl-dev:native <!pkg.linux.nokernel>, libssl-dev <!pkg.linux.notools>, openssl <!pkg.linux.nokernel>, libelf-dev:native <!pkg.linux.nokernel>, libelf-dev [linux-any] <!pkg.linux.notools>, lz4 [amd64 arm64] <!pkg.linux.nokernel>, pahole <!pkg.linux.nokernel> | dwarves:native (>= 1.16~) <!pkg.linux.nokernel>, cpio <!pkg.linux.nokernel>, xz-utils <!pkg.linux.nokernel>, zstd <!pkg.linux.nokernel>, bison <!pkg.linux.nokernel>, bison <!pkg.linux.notools>, flex <!pkg.linux.nokernel>, flex <!pkg.linux.notools>, gcc-14 [alpha amd64 arm64 armel armhf hppa loong64 m68k mips mips64 mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64] <!cross !pkg.linux.nokernel>, gcc-14-alpha-linux-gnu [alpha] <cross !pkg.linux.nokernel>, gcc-14-x86-64-linux-gnu [amd64] <cross !pkg.linux.nokernel>, gcc-14-aarch64-linux-gnu [arm64] <cross !pkg.linux.nokernel>, gcc-arm-linux-gnueabihf [arm64] <!pkg.linux.nokernel>, gcc-14-arm-linux-gnueabi [armel] <cross !pkg.linux.nokernel>, gcc-14-arm-linux-gnueabihf [armhf] <cross !pkg.linux.nokernel>, gcc-14-hppa-linux-gnu [hppa] <cross !pkg.linux.nokernel>, gcc-14-hppa64-linux-gnu [hppa] <!pkg.linux.nokernel>, gcc-14-loongarch64-linux-gnu [loong64] <cross !pkg.linux.nokernel>, gcc-14-m68k-linux-gnu [m68k] <cross !pkg.linux.nokernel>, gcc-14-mips-linux-gnu [mips] <cross !pkg.linux.nokernel>, gcc-14-mips64-linux-gnuabi64 [mips64] <cross !pkg.linux.nokernel>, gcc-14-mips64el-linux-gnuabi64 [mips64el] <cross !pkg.linux.nokernel>, gcc-14-mipsisa64r6el-linux-gnuabi64 [mips64r6el] <cross !pkg.linux.nokernel>, gcc-14-mipsel-linux-gnu [mipsel] <cross !pkg.linux.nokernel>, gcc-14-powerpc-linux-gnu [powerpc] <cross !pkg.linux.nokernel>, gcc-14-powerpc64-linux-gnu [ppc64] <cross !pkg.linux.nokernel>, gcc-14-powerpc64le-linux-gnu [ppc64el] <cross !pkg.linux.nokernel>, gcc-14-riscv64-linux-gnu [riscv64] <cross !pkg.linux.nokernel>, gcc-14-s390x-linux-gnu [s390x] <cross !pkg.linux.nokernel>, gcc-14-sh4-linux-gnu [sh4] <cross !pkg.linux.nokernel>, gcc-14-sparc64-linux-gnu [sparc64] <cross !pkg.linux.nokernel>, python3-docutils [amd64 arm64 armhf i386 linux-any x32] <!nodoc !pkg.linux.notools> <!pkg.linux.mintools !pkg.linux.notools>, binutils-dev [hppa] <!pkg.linux.mintools !pkg.linux.notools>, zlib1g-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libcap-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libpci-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libnl-3-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libnl-genl-3-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, asciidoctor [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nodoc !nopython !pkg.linux.notools>, gcc-multilib [amd64 mips64 mips64el mips64r6 mips64r6el ppc64 s390x sparc64] <!cross>, libaudit-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libbabeltrace-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libdebuginfod-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libdw-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libnewt-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libnuma-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libopencsd-dev (>= 1.1.1) [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libperl-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libpython3-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libtraceevent-dev (>= 1:1.5) [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64 x32] <!pkg.linux.mintools !pkg.linux.notools>, libunwind-dev [amd64 arm64 armel armhf hppa i386 mips mips64 mips64el mipsel powerpc ppc64 ppc64el sh4] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libzstd-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, python3-dev:any [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, python3-setuptools [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, autoconf [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, automake [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libtool [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libglib2.0-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libudev-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libwrap0-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, rsync [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libtracefs-dev (>= 1.3) [amd64 arm64 armhf i386 x32] <!pkg.linux.mintools !pkg.linux.notools>, kernel-wedge (>= 2.105~) [alpha amd64 arm64 armel armhf hppa loong64 m68k mips mips64 mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64] <!pkg.linux.nokernel>, kmod [alpha amd64 arm64 armel armhf hppa loong64 m68k mips mips64 mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64] <!pkg.linux.nokernel>
Build-Depends-Indep: cpio <!nodoc !pkg.linux.quick>, graphviz <!nodoc !pkg.linux.quick>, python3-sphinx <!nodoc !pkg.linux.quick>, python3-sphinx-rtd-theme <!nodoc !pkg.linux.quick>, texlive-latex-base <!nodoc !pkg.linux.quick>, texlive-latex-extra <!nodoc !pkg.linux.quick>, dvipng <!nodoc !pkg.linux.quick>, python3-yaml <!nodoc !pkg.linux.quick>, sphinx-common <!nodoc !pkg.linux.quick>, patchutils <!pkg.linux.nosource !pkg.linux.quick>, xz-utils <!pkg.linux.nosource !pkg.linux.quick>, rsync
Rules-Requires-Root: no
Homepage: https://www.kernel.org/
Vcs-Browser: https://salsa.debian.org/kernel-team/linux
Vcs-Git: https://salsa.debian.org/kernel-team/linux.git

Package: bpftool
Architecture: linux-any
Section: devel
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Inspection and simple manipulation of BPF programs and maps
 The bpftool command allows for inspection and simple modification of
 Berkeley Packet Filter (BPF) objects on the system.

Package: hyperv-daemons
Architecture: amd64 arm64 i386 x32
Section: admin
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Support daemons for Linux running on Hyper-V
 Suite of daemons for Linux guests running on Hyper-V, consisting of
 hv_kvp_daemon and hv_vss_daemon.
 .
 hv_kvp_daemon provides the key-value pair (KVP) service, allowing the host
 to get and set the IP networking configuration of the guest.  (This
 requires helper scripts which are not currently included.)
 .
 hv_vss_daemon provides the volume shadow copy service (VSS), allowing the
 host to freeze the guest filesystems while taking a snapshot.

Package: intel-sdsi
Architecture: amd64
Section: admin
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel On Demand (SDSi) provisioning tool
 intel_sdsi is a tool for key certificate and activation payload
 provisioning on Intel Xeon family processors with support for Intel On
 Demand (formerly known as Software Defined Silicon or SDSi).
 .
 intel_sdsi allows the configuration of additional CPU features through a
 license activation process.

Package: libcpupower-dev
Architecture: linux-any
Section: libdevel
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Provides: libcpufreq-dev
Depends: ${misc:Depends}, libcpupower1 (= ${binary:Version})
Replaces: libcpufreq-dev
Conflicts: libcpufreq-dev
Description: CPU frequency and voltage scaling tools for Linux (development files)
 libcpupower is a library for inspecting and controlling cpufreq and
 cpuidle tunables.
 .
 This package is needed to compile programs against libcpupower.

Package: libcpupower1
Architecture: linux-any
Section: libs
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPU frequency and voltage scaling tools for Linux (libraries)
 libcpupower is a library for inspecting and controlling cpufreq and
 cpuidle tunables.
 .
 This package contains the shared library.

Package: linux-bpf-dev
Architecture: alpha amd64 arm64 armhf hppa loong64 m68k ppc64 ppc64el riscv64 s390x sparc64
Section: devel
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: ${misc:Depends}
Multi-Arch: same
Description: Headers for BPF development
 The vmlinux.h header is provided to allow userspace to build BPF CO-RE
 programs targeting the packaged kernel.

Package: linux-config-6.12
Architecture: linux-any
Build-Profiles: <!pkg.linux.nosource>
Depends: ${misc:Depends}
Recommends: linux-source-6.12
Multi-Arch: same
Description: Debian kernel configurations for Linux 6.12
 This package contains the configuration files used to build the official
 Debian kernel files, but without references to Debian's signing
 certificates.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

DEB_VERSION_SOURCE = $(shell echo '$(DEB_VERSION)' | sed -re 's/\+b([0-9]+)$$//')

SHELL    := sh -e

include debian/rules.defs

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  DEBIAN_KERNEL_JOBS := $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
ifdef DEBIAN_KERNEL_JOBS
  MAKEFLAGS += -j$(DEBIAN_KERNEL_JOBS)
endif

# dpkg-buildpackage passes the -s option if DEB_BUILD_OPTIONS contains
# terse, but that triggers Kbuild to turn off progress messages
# completely, which we don't want.
override MAKEFLAGS := $(subst s,,$(filter-out -%,$(MAKEFLAGS))) $(filter -%,$(MAKEFLAGS))

.NOTPARALLEL:

source: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen source

setup: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen setup_$(DEB_HOST_ARCH)

build: build-arch build-indep

build-arch: debian/control
	dh_testdir

# The perf-read-vdso* programs are built for different architectures,
# without standard flags, but are not exposed to untrusted input.
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -o *[^ ]*/perf-read-vdso.*'

# Kernel code needs different hardening options that blhc doesn't know
# about.
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -D__KERNEL__ .*'

# The tools/perf/tests/workloads/.* programs are deliberately compiled
# without -O2, so instruct blhc to ignore those
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -o .*tools/perf/tests/workloads/.*'

# fixdep is not always built with the right flags but is also not packaged
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -o .*/tools/.*/fixdep.*'

# We need to use terse builds in CI due to the log size limit.  This
# mostly affects the output for builds of kernel code, which need
# different options for hardening anyway.
ifneq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
	@printf '%s\n' 'blhc: ignore-line-regexp: \s*(CC(LD)?|LD|LINK)\b.*'
endif

	$(MAKE) -f debian/rules.gen build-arch_$(DEB_HOST_ARCH)

build-indep: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen build-indep

binary:	binary-indep binary-arch

binary-arch: build-arch
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-arch_$(DEB_HOST_ARCH)

binary-indep: build-indep
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-indep

DIR_ORIG = ../orig/$(DEB_SOURCE)-$(DEB_VERSION_EPOCH_UPSTREAM)
TAR_ORIG = ../$(DEB_SOURCE)_$(DEB_VERSION_EPOCH_UPSTREAM).orig.tar.xz

orig: $(DIR_ORIG)
	rsync --delete --exclude /debian --exclude .git --link-dest=$(DIR_ORIG)/ -a $(DIR_ORIG)/ .
	QUILT_PATCHES='$(CURDIR)/debian/patches' QUILT_PC=.pc quilt push --quiltrc - -a -q --fuzz=0

$(DIR_ORIG): $(TAR_ORIG)
	mkdir -p ../orig
	tar -C ../orig -xaf $(TAR_ORIG)

CLEAN_PATTERNS := $(BUILD_DIR) $(STAMPS_DIR) debian/lib/python/debian_linux/*.pyc debian/lib/python/debian_linux/__pycache__ $$(find debian -maxdepth 1 -type d -name 'linux-*') debian/*-modules-*-di* debian/kernel-image-*-di* debian/*-tmp debian/*.substvars

clean-generated:
	rm -rf $(CLEAN_PATTERNS)
# We cannot use dh_clean here because it requires debian/control to exist
	rm -rf debian/.debhelper debian/*.debhelper* debian/files debian/generated.*
	rm -f \
		debian/control \
		debian/control.md5sum \
		debian/linux-doc.maintscript \
		debian/linux-headers-*.maintscript \
		debian/linux-headers-*.postinst \
		debian/linux-image-*.NEWS \
		debian/linux-image-*.bug-presubj \
		debian/linux-image-*.lintian-overrides \
		debian/linux-image-*.maintscript \
		debian/linux-image-*.postinst \
		debian/linux-image-*.postrm \
		debian/linux-image-*.preinst \
		debian/linux-image-*.prerm \
		debian/linux-source.maintscript \
		debian/rules.gen \
		debian/tests/control

maintainerclean: clean-generated
	rm -rf $(filter-out debian .git, $(wildcard * .[^.]*))

clean: debian/control
	dh_testdir
	rm -rf $(CLEAN_PATTERNS)
	dh_clean

CONTROL_FILES = $(BUILD_DIR)/version-info $(wildcard debian/templates/*.in)
CONTROL_FILES += debian/config/defines.toml $(wildcard debian/config/*/defines.toml)
CONTROL_FILES += debian/installer/package-list

# debian/bin/gencontrol.py uses debian/changelog as input, but the
# output only depends on the source name and version.  To avoid
# frequent changes to debian/control.md5sum, include only those fields
# in the checksum.
$(BUILD_DIR)/version-info: debian/changelog
	mkdir -p $(@D)
# Use DEB_VERSION_SOURCE to allow binNMU
	printf >$@ 'Source: %s\nVersion: %s\n' $(DEB_SOURCE) $(DEB_VERSION)

debian/control debian/rules.gen: debian/bin/gencontrol.py $(CONTROL_FILES)
ifeq ($(wildcard debian/control.md5sum),)
	$(MAKE) -f debian/rules debian/control-real
else
	md5sum --check debian/control.md5sum --status || \
		$(MAKE) -f debian/rules debian/control-real
endif

debian/control-real: debian/bin/gencontrol.py $(CONTROL_FILES)
# Hash randomisation makes the pickled config unreproducible
	PYTHONHASHSEED=0 $<
	md5sum $(sort $^) > debian/control.md5sum
	@echo
	@echo This target is made to fail intentionally, to make sure
	@echo that it is NEVER run during the automated build. Please
	@echo ignore the following error, the debian/control file has
	@echo been generated SUCCESSFULLY.
	@echo
	exit 1

.PHONY: binary binary-% build build-% clean debian/control-real orig setup source clean-generated

=== debian/tests/control ===
Test-Command: py.test debian/lib/python
Restrictions: superficial
Depends: python3-pytest, python3-jinja2

Test-Command: debian/tests/headers-kbuild 6.12.31-alpha-generic
Architecture: alpha
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-alpha-generic
Depends: linux-headers-6.12.31-alpha-generic, linux-image-6.12.31-alpha-generic

Test-Command: debian/tests/headers-kbuild 6.12.31-alpha-smp
Architecture: alpha
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-alpha-smp
Depends: linux-headers-6.12.31-alpha-smp, linux-image-6.12.31-alpha-smp

Test-Command: debian/tests/headers-kbuild 6.12.31-amd64
Architecture: amd64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-amd64
Depends: linux-headers-6.12.31-amd64, linux-image-6.12.31-amd64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-cloud-amd64
Architecture: amd64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-cloud-amd64
Depends: linux-headers-6.12.31-cloud-amd64, linux-image-6.12.31-cloud-amd64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-rt-amd64
Architecture: amd64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rt-amd64
Depends: linux-headers-6.12.31-rt-amd64, linux-image-6.12.31-rt-amd64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-arm64
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-arm64
Depends: linux-headers-6.12.31-arm64, linux-image-6.12.31-arm64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-cloud-arm64
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-cloud-arm64
Depends: linux-headers-6.12.31-cloud-arm64, linux-image-6.12.31-cloud-arm64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-arm64-16k
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-arm64-16k
Depends: linux-headers-6.12.31-arm64-16k, linux-image-6.12.31-arm64-16k-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-rt-arm64
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rt-arm64
Depends: linux-headers-6.12.31-rt-arm64, linux-image-6.12.31-rt-arm64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.31-rpi
Architecture: armel
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi
Depends: linux-headers-6.12.31-rpi, linux-image-6.12.31-rpi

Test-Command: debian/tests/headers-kbuild 6.12.31-armmp
Architecture: armhf
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-armmp
Depends: linux-headers-6.12.31-armmp, linux-image-6.12.31-armmp

Test-Command: debian/tests/headers-kbuild 6.12.31-armmp-lpae
Architecture: armhf
Restrictions: skip-not-installable, superficial
